/* InvoiceController */

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>
#import "Class.h"

@interface InvoiceController : NSArrayController
{
	IBOutlet MyDocument			* document;
	IBOutlet NSArrayController	* paymentController;
	IBOutlet NSArrayController	* personController;
	
	IBOutlet NSBox				* toolbarBox;
	IBOutlet NSMenu				* addMenu;
	IBOutlet NSMenu				* actionMenu;
	IBOutlet NSMenu				* invoiceActionMenu;

	IBOutlet NSButton			* allFilterButton;
	IBOutlet NSButton			* outboxFilterButton;
	IBOutlet NSButton			* outstandingFilterButton;
	IBOutlet NSButton			* overdueFilterButton;
	IBOutlet NSButton			* paidFilterButton;
	
	IBOutlet NSImageView		* invoiceStatusImage;
	
	IBOutlet NSTextField		* createdDateField;
	IBOutlet NSTextField		* dueDateField;

	IBOutlet NSTextField		* subtotalField;
	IBOutlet NSTextField		* tax1Field;
	IBOutlet NSTextField		* tax2Field;
	IBOutlet NSTextField		* tax3Field;
	IBOutlet NSTextField		* totalField;
	IBOutlet NSTextField		* dueField;
	
	IBOutlet AWSplitView		* splitView;
	IBOutlet AWView				* detailsView;
	IBOutlet AWView				* inspectorView;
	IBOutlet NSTabView			* inspectorTabView;
	IBOutlet NSTableView		* tableView;
	IBOutlet NSView				* invoiceDetailView;
	
	IBOutlet NSWindow			* addInvoicesWindow;
	IBOutlet NSTextField		* addInvoicesDateField;
	IBOutlet NSPopUpButton		* addInvoicesStatusPopUpButton;
	IBOutlet NSPopUpButton		* addInvoicesPersonPopUpButton;
	IBOutlet NSPopUpButton		* addInvoicesTaskPopUpButton;
	IBOutlet NSMatrix			* addInvoicesMode;
	
	IBOutlet NSPopUpButton		* itemTitlePopUpButton;
	IBOutlet NSTextField		* itemAmountField;

	IBOutlet NSTextField		* estimatedTimeField;
	IBOutlet NSTextField		* actualTimeField;
	IBOutlet NSTextField		* actualExpensesField;
	IBOutlet NSTextField		* invoicedTimeField;
	IBOutlet NSTextField		* invoicedExpensesField;
	
	IBOutlet NSTextField		* expenseDateField;
	IBOutlet NSTextField		* expenseAmountField;
	
	IBOutlet NSWindow			* previewWindow;
	IBOutlet WebView			* previewView;
}

- (NSView *)detailsView;
- (NSView *)inspectorView;
- (NSTableView *)tableView;

- (IBAction)handleClickFilterButton:(id)sender;
- (IBAction)handleChangeStatusForSelectedObject:(id)sender;
- (IBAction)handleExportRTFTypeForSelectedObject:(id)sender;
- (IBAction)handleExportHTMLTypeForSelectedObject:(id)sender;
- (IBAction)handleEmailRTFTypeForSelectedObject:(id)sender;
- (IBAction)handleClipboardCopyRTFTypeForSelectedObject:(id)sender;
- (IBAction)handlePreviewHTMLTypeForSelectedObject:(id)sender;
- (IBAction)handleExportQIFTypeForInvoices:(id)sender;
- (void)didEnd:(NSSavePanel *)sheet returnCode:(int)code type:(NSString *)type;
- (IBAction)handleSelectTabViewItem:(id)sender;

- (IBAction)beginAddInvoicesSheet:(id)sender;
- (IBAction)addInvoicesFromSheet:(id)sender;
- (IBAction)cancelAddInvoicesSheet:(id)sender;
- (IBAction)handleSelectStatusInSheet:(id)sender;
- (IBAction)handleSelectPersonInSheet:(id)sender;
- (IBAction)handleSelectTaskInSheet:(id)sender;
- (IBAction)handleChangeTax:(id)sender;

- (NSManagedObject *)newInvoiceForPerson:(NSManagedObject *)person withInvoiceItems:(NSArray *)invoiceItems;
- (NSMutableArray *)newInvoiceItemsForTaskAndChildrenOfTask:(NSManagedObject *)task;
- (NSManagedObject *)newInvoiceItemForTask:(NSManagedObject *)task forQuantity:(float)qty;
- (NSManagedObject *)newInvoiceItemForExpense:(NSManagedObject *)task forQuantity:(float)qty;

- (void)recalculateTaxesForInvoice:(NSManagedObject *)invoice;

@end
