/* LogItemController */

#import <Cocoa/Cocoa.h>
#import "Class.h"

@interface LogItemController : NSArrayController
{
	IBOutlet MyDocument				* document;
	IBOutlet NSArrayController		* categoryController;
	IBOutlet NSArrayController		* personController;
	
	NSTimer * timer;
	
	NSMutableArray * dates;
	NSPredicate * predicate;
	
	IBOutlet NSButton				* allFilterButton;
	IBOutlet NSButton				* todayFilterButton;
	IBOutlet NSButton				* thisWeekFilterButton;
	IBOutlet NSButton				* thisMonthFilterButton;
	
	IBOutlet NSTextField			* startTimeField;
	IBOutlet NSTextField			* stopTimeField;
	IBOutlet NSTextField			* totalTimeField;
	
	IBOutlet AWView					* detailsView;
	IBOutlet AWView					* inspectorView;
	IBOutlet AWTimesheetView		* outlineView;

	IBOutlet NSBox					* toolbarBox;
	IBOutlet NSMenu					* addMenu;
	IBOutlet NSMenu					* actionMenu;

	IBOutlet NSPopUpButton			* taskPopUpButton;
	
	IBOutlet NSWindow				* addLogItemWindow;
	IBOutlet NSPopUpButton			* addLogItemStatusPopUpButton;
	IBOutlet NSPopUpButton			* addLogItemPersonPopUpButton;
	IBOutlet NSPopUpButton			* addLogItemTaskPopUpButton;
	IBOutlet NSBox					* addLogItemTaskBox;
	IBOutlet NSTextField			* addLogItemTaskNameField;
	IBOutlet NSPopUpButton			* addLogItemTaskCategoryPopUpButton;
	IBOutlet NSMatrix				* addLogItemMode;
	IBOutlet NSTextField			* addLogItemTotalTimeField;
	IBOutlet NSButton				* addLogItemAddButton;

	IBOutlet NSTextField			* estimatedTimeField;
	IBOutlet NSTextField			* actualTimeField;
	IBOutlet NSTextField			* actualExpensesField;
	IBOutlet NSTextField			* invoicedTimeField;
	IBOutlet NSTextField			* invoicedExpensesField;
}

- (NSArray *)arrayOfObjectsOfItem:(id)item;

- (NSView *)detailsView;
- (NSView *)inspectorView;

- (void)update;
- (void)reload;
- (IBAction)handleReload:(id)sender;

- (IBAction)handleAddLogItem:(id)sender;
- (IBAction)handleBeginNowLogItemForSelectedObject:(id)sender;
- (void)beginAddLogItemSheet:(id)sender contextInfo:(id)info;
- (IBAction)handleAddPersonFromSheet:(id)sender;
- (IBAction)handleAddFromSheet:(id)sender;
- (IBAction)handleCancelFromSheet:(id)sender;
- (IBAction)handleSelectStatusInSheet:(id)sender;
- (IBAction)handleSelectPersonInSheet:(id)sender;
- (IBAction)handleSelectTaskInSheet:(id)sender;
- (IBAction)handleSelectModeInSheet:(id)sender;

- (IBAction)handleAddExpense:(id)sender;

- (void)updateTaskPopUpButtonInSheet:(id)sender;
- (NSMenu *)menuForItemsWithParent:(NSManagedObject *)parent;
- (NSMenuItem *)menuItemForTask:(id)task;

- (IBAction)handleClickFilterButton:(id)sender;
- (void)handleSelectedRowDidChange:(id)sender;
- (IBAction)handleClickTimerButton:(id)sender;
- (void)handleTimerDidFire:(NSTimer *)timer;
- (IBAction)handleSetStartTime:(id)sender;
- (IBAction)handleSetStopTime:(id)sender;
- (IBAction)handleSetTotalTime:(id)sender;
- (IBAction)handleStop:(id)sender;

- (NSMenu *)menuForItem:(id)item;
- (NSMenu *)menuForItemsWithParent:(NSManagedObject *)parent forItem:(id)item;
- (NSMenuItem *)menuItemForTask:(id)task forItem:(id)item;
- (IBAction)handleSelectTask:(id)sender;

- (void)calculateStartTimeForLogItem:(NSManagedObject *)logItem;
- (void)calculateStopTimeForLogItem:(NSManagedObject *)logItem;
- (void)calculateTotalTimeForLogItem:(NSManagedObject *)logItem;

@end
