/* TaskController */

#import <Cocoa/Cocoa.h>
#import "Class.h"

@interface TaskController : NSArrayController
{
	IBOutlet MyDocument				* document;
	IBOutlet NSArrayController		* categoryController;
	IBOutlet NSArrayController		* expenseController;
	IBOutlet NSArrayController		* personController;
	
	IBOutlet NSBox					* toolbarBox;
	IBOutlet NSMenu					* addMenu;
	IBOutlet NSMenu					* actionMenu;

	IBOutlet NSButton				* allFilterButton;
	IBOutlet NSButton				* prospectFilterButton;
	IBOutlet NSButton				* activeFilterButton;
	IBOutlet NSButton				* holdFilterButton;
	IBOutlet NSButton				* completeFilterButton;
	IBOutlet NSButton				* deadFilterButton;
	
	IBOutlet NSTextField			* estimatedTimeField;
	IBOutlet NSTextField			* actualTimeField;
	IBOutlet NSTextField			* actualExpensesField;
	IBOutlet NSTextField			* invoicedTimeField;
	IBOutlet NSTextField			* invoicedExpensesField;
	IBOutlet NSTextField			* createdDateField;
	IBOutlet NSTextField			* dueDateField;
	IBOutlet NSTextField			* numberField;

	IBOutlet NSTextField			* totalExpensesField;
	IBOutlet NSTextField			* totalTimeField;
	
	IBOutlet AWView					* detailsView;
	IBOutlet AWView					* inspectorView;
	IBOutlet NSTabView				* inspectorTabView;
	IBOutlet NSOutlineView			* outlineView;
	
	IBOutlet NSWindow				* addTaskWindow;
	IBOutlet NSTextField			* addTaskNameField;
	IBOutlet NSPopUpButton			* addTaskCategoryPopUpButton;
	IBOutlet NSPopUpButton			* addTaskPersonPopUpButton;
	IBOutlet NSPopUpButton			* addTaskStatusPopUpButton;
	IBOutlet NSTextField			* addTaskCreatedDateField;
	IBOutlet NSTextField			* addTaskDueDateField;
	IBOutlet NSPopUpButton			* addTaskInvoicePersonPopUpButton;
	IBOutlet NSButton				* addTaskAddButton;
	
	IBOutlet NSWindow				* categoriesWindow;
	
	NSPredicate						* filterPredicate;
}

- (NSView *)detailsView;
- (NSView *)inspectorView;

- (void)addChild:(id)sender;
- (void)didEnd:(NSWindow *)sheet returnCode:(int)code remove:(id)object;

- (IBAction)handleArrangeTasks:(id)sender;
- (IBAction)handleExportToICal:(id)sender;
- (IBAction)handleClickFilterButton:(id)sender;
- (void)handleSelectedRowDidChange:(id)sender;
- (IBAction)handleSelectTabViewItem:(id)sender;
- (IBAction)handleClickLockButton:(id)sender;

- (IBAction)handleAddTask:(id)sender;
- (void)beginAddTaskSheet:(id)sender contextInfo:(id)info;
- (IBAction)handleAddFromSheet:(id)sender;
- (IBAction)handleCancelFromSheet:(id)sender;
- (IBAction)handleEditCategories:(id)sender;
- (void)beginEditCategoriesSheet:(id)sender contextInfo:(id)info;
- (IBAction)handleEditCategoriesFromSheet:(id)sender;
- (IBAction)handleDoneFromCategoriesSheet:(id)sender;
- (IBAction)handleAddPersonFromSheet:(id)sender;
- (void)didEnd:(NSWindow *)sheet returnCode:(int)code contextInfo:(id)info;

@end
